#!/usr/bin/perl
### clean_files_imdir.pl

use Env qw(INT_SCR INT_BIN MAI_SCR);
use lib "$INT_SCR";  #### Location of Generic.pm
use Generic;


# Usage : clean_files_imdir.pl date

###Usage info/check

sub Usage{

`$MAI_SCR/pod2man_mai.pl $MAI_SCR/clean_files_imdir.pl`;
exit 1;
}

@ARGV == 1 or Usage();
@args = @ARGV;

$prefix     = shift;

$outfilef    = "$prefix"."_f.slc";
$outfileb    = "$prefix"."_b.slc";
$roimaiin    = "$prefix"."_roi_mai.in";
$roimaiout   = "$prefix"."_roi_mai.out";
$rscoutfilef = "$prefix"."_f.slc.rsc";
$rscoutfileb = "$prefix"."_b.slc.rsc";

`rm ./$outfilef`;
`rm ./$outfileb`;
`rm ./$roimaiin`;
`rm ./$roimaiout`;
`rm ./$rscoutfilef`;
`rm ./$rscoutfileb`;

exit 0;

=pod

=head1 USAGE

B<clean_files_imdir.pl> I<image_date> 
  
=head1 FUNCTION

Erazes MAI files (and only MAI files) from one SAR image directory

=head1 HISTORY

Perl  Script : Noa BD Bechor, 01/02/2008
Modification: Noa BD Bechor, 25/Sep/2010

=head1 LAST UPDATE

Noa BD Bechor 2010/09/25

=cut


