#!/usr/bin/perl
### clean_files_intdir.pl

use Env qw(INT_SCR INT_BIN MAI_SCR);
use lib "$INT_SCR";  #### Location of Generic.pm
use Generic;


# Usage : clean_files_intdir.pl date

###Usage info/check

sub Usage{

`$MAI_SCR/pod2man_mai.pl  $MAI_SCR/clean_files_intdir.pl`;
exit 1;
}

@ARGV == 2 or Usage();
@args = @ARGV;

$date1    = shift;
$date2    = shift;
$intfilef  = "$date1-${date2}"."_f.int.rsc";
$intfileb  = "$date1-${date2}"."_b.int.rsc";
$maifilersc   = "$date1-${date2}.mai.rsc";
$maifile   = "$date1-${date2}.mai";
$ampfilef  = "$date1-${date2}"."_f.amp.rsc";
$ampfileb  = "$date1-${date2}"."_b.amp.rsc";
$resamp_mai = "$date1-${date2}"."_resamp_mai.in";
$resampout  = "$date1-${date2}"."_resamp_mai.out";
$intf        = "$date1-${date2}"."_f.int";
$intb        = "$date1-${date2}"."_b.int";
$ampf        = "$date1-${date2}"."_f.amp";
$ampb        = "$date1-${date2}"."_b.amp";
$geofile     = "geo"."_"."$date1-${date2}"."_MAI.hgt";
$geofilersc  = "geo"."_"."$date1-${date2}"."_MAI.hgt.rsc";
$file1f    = "$date1"."_f.slc";
$file2f    = "$date2"."_f.slc";
$file1b    = "$date1"."_b.slc";
$file2b    = "$date2"."_b.slc";
$file1frsc    = "$date1"."_f.slc.rsc";
$file2frsc    = "$date2"."_f.slc.rsc";
$file1brsc    = "$date1"."_b.slc.rsc";
$file2brsc    = "$date2"."_b.slc.rsc";
$roimaiin1    = "$date1"."_roi_mai.in";
$roimaiin2    = "$date2"."_roi_mai.in";

`rm ./$intfilef`;
`rm ./$intfileb`;
`rm ./$maifilersc`;
`rm ./$maifile`;
`rm ./$ampfilef`;
`rm ./$ampfileb`;
`rm ./$resamp_mai`;
`rm ./$resampout`;
`rm ./$intf`;
`rm ./$intb`;
`rm ./$ampf`;
`rm ./$ampb`;
`rm ./$file1f`;
`rm ./$file2f`;
`rm ./$file1b`;
`rm ./$file2b`;
`rm ./$file1frsc`;
`rm ./$file2frsc`;
`rm ./$file1brsc`;
`rm ./$file2brsc`;
`rm ./$geofile`;
`rm ./$geofilersc`;
`rm ./log ./log1`;
`rm ./$roimaiin1`;
`rm ./$roimaiin2`;

exit 0;

=pod

=head1 USAGE

B<clean_files_intdir.pl> I<date1 date2> 
  
=head1 FUNCTION

Erazes MAI files (and only MAI files) from the MAI interferogram directory, date1-date2-MAI

=head1 HISTORY

Perl  Script : Noa BD Bechor, 01/02/2008
Modification: Noa BD Bechor, 25/Sep/2010

=head1 LAST UPDATE

Noa BD Bechor 2010/09/25

=cut


