c
c mai_topo  reads DEM in radar coordinates, calculates topographic 
c           correction.
c
c
c           inputs: baseline_f, baseline_b
c                   MaiFrac, Dopplers
c                   orbit parameters
c
c
c23456789  


	program get_time
	
c	implicit none  
	
	
     	integer*4    nnn, mmm, overlap, ndiv, nbytesmax

     	parameter    (nnn = 4096,mmm = 16384, overlap = 0)
     	parameter    (nbytesmax = 16384, ndiv = 4)

     	real*4       dem(nnn,mmm)
	
	byte	     inbuf(16384)
     	dimension    a(16384),b(16384),d(16384)
	complex      box
	
	real*8	     azres, c, veleff_f, veleff_b
	real*8 	     sinsq_f, sinsq_b, sq_f,sq_b
	real*8	     nl_const
     	
	real*8       fdf, fdb, fs, prf, vel 
	real*8 	     BH_f, BV_f, BH_b, BV_b
	real*8 	     Lf, Lb, alpha_f, alpha_b, pren_f, pren_b
	real*8	     r_platvel(3), r_platacc(3), r_veln
     	real*8       r001, r01, r0, delr, H, wavl, re, gm
	real*8       pi,r(mmm), th, thazf,thazb,thsqf,thsqb
	real*8       r_lookvec_f(3),r_vdotl_f, r_adotl_f
	real*8       r_lookvec_b(3),r_vdotl_b, r_adotl_b
	real*8	     delta_r_fb(nnn,mmm)
     	
	character*20 name_int,name_dem,out_dem 
	character*64 leftright
     	character*1  deskew, iqflip, srm
     	
	integer*4    nlooks_dem, isave, nextend, i_lrl
     	integer*4    dem_radar, phase_dem, nwr
	integer*4    intlen, demlen, intwidth, demwidth, i, j, k
     	


c--------Read input file	
	
c	print *, 'Master satellite height ? '
	read(*,*)H
c	print*, H
c	print *, 'Master satellite r0 ? '
	read(*,*)r001
c	print*, r001
c	print *, 'Master satellite velocity vector? '
	read(*,*)r_platvel
c	print*, r_platvel
c	print *, 'Master satellite acceleration vector ? '
	read(*,*)r_platacc
c	print*, r_platacc
c	print *,' Start range bin ?'
	read(*,*)isave
c	print*, isave
c	print *,' Range chirp extention points ?'
	read(*,*)nextend
c	print*, nextend
c	print *,' Left, Right or Unknown Pointing ?'
	read(*,*)leftright
      	i_lrl = 0
      	if(leftright .eq. 'Left' .or. leftright .eq. 'LEFT' .or.
     $     	leftright .eq. 'left') then
         	i_lrl = 1
      	elseif(leftright .eq. 'Right' .or. leftright .eq. 'RIGHT' .or.
     $        	leftright .eq. 'right') then
         	i_lrl = -1
      	end if
c	print *, 'Earth radius ? '
	read(*,*)re
c	print*, re
c	print *, 'Sampling rate ? '
	read(*,*)fs
c	print*, fs
c	print *, 'Wavelength ? '
	read(*,*)wavl
c	print*, wavl
c	print *, 'Forward, aft Doppler centroid ? '
	read(*,*)fdf,fdb
c	print*, fdf,fdb
c	print *, 'PRF ? '
	read(*,*)prf
c	print*, prf
c	print *, 'Planet GM ? '
	read(*,*)gm
c	print*, gm
	
	
	c = 299792456.
	delr = c/fs/2.d0
	
      	r0 = r001 + (isave-nextend-1) * delr
	fdf = fdf*prf
	fdb = fdb*prf
	
        pi=4.d0*atan2(1.d0,1.d0)
				
      	call norm(r_platvel,r_veln)
     		
      
	i = 1

            r(i) = r0 + (float((i-1)*nlooks_dem)+nl_const)*delr
            th=acos(((H+re)**2+r(i)*r(i)-re**2)/(2.d0*r(i)*(re+H)))
         thazf = asin(((wavl*fdf/(2.d0*sin(th)))+
     $	 	(r_platvel(3)/tan(th)))/
     $          sqrt(r_platvel(1)**2+r_platvel(2)**2))-
     $		i_lrl*atan(r_platvel(2)/r_platvel(1))
	
            r_lookvec_f(1) =  sin(th)*sin(thazf)
            r_lookvec_f(2) =  sin(th)*cos(thazf)*i_lrl
            r_lookvec_f(3) = -cos(th)
            
            r_vdotl_f = dot(r_lookvec_f,r_platvel)
            r_adotl_f = dot(r_lookvec_f,r_platacc)

            veleff_f = sqrt(-(r_adotl_f*r(i) + 
     $	    	r_vdotl_f**2 - r_veln**2))
            sinsq_f  = wavl*fdf/2./veleff_f
	    sq_f     = asin(sinsq_f)
	    alpha_f = atan2(BV_f,BH_f)+pi/2-th
	    
	    
         thazb = asin(((wavl*fdb/(2.d0*sin(th)))+
     $	 	(r_platvel(3)/tan(th)))/
     $          sqrt(r_platvel(1)**2+r_platvel(2)**2))-
     $		i_lrl*atan(r_platvel(2)/r_platvel(1))
	
            r_lookvec_b(1) =  sin(th)*sin(thazb)
            r_lookvec_b(2) =  sin(th)*cos(thazb)*i_lrl
            r_lookvec_b(3) = -cos(th)
            
            r_vdotl_b = dot(r_lookvec_b,r_platvel)
            r_adotl_b = dot(r_lookvec_b,r_platacc)

            veleff_b = sqrt(-(r_adotl_b*r(i) + 
     $	    	r_vdotl_b**2 - r_veln**2))
	    sinsq_b  = wavl*fdb/2./veleff_b
	    sq_b     = asin(sinsq_b)
	    alpha_b = atan2(BV_b,BH_b)+pi/2-th
	    

c	print*,'\nVELEFF_F             ',veleff_f	                                                                                                                                                
c	print*,'\nVELEFF_B             ',veleff_b	                                                                                                                                                
        ! if doesn't work for you, use suggestion by Wanpeng Feng:
	write(*,'(A10,e20.10)')   'VELEFF_F  ',veleff_f
	write(*,'(A10,e20.10)')   'VELEFF_B  ',veleff_b
                                                                                                                                                
                                                                                                               
	end

