#!/usr/bin/perl
### mai.pl

$] >= 5.004 or die "Perl version must be >= 5.004 (Currently $]).\n";

use Env qw(INT_SCR INT_BIN MAI_SCR ROI_MAI);
use lib "$INT_SCR";  #### Location of Generic.pm
use Generic;

###Usage info/check

sub Usage{

`$MAI_SCR/pod2man_mai.pl  $MAI_SCR/mai.pl`;
exit 1;
}
@ARGV == 5 or Usage();
@args = @ARGV;

$prefix     = shift;
$roimai      = shift;
$roiout     = shift;
$outfilef    = shift;
$outfileb    = shift;

-r $roimai or die "Can't read $roimai\n";


##########################
Message "Checking I/O";
##########################
@Infiles    = ($roimai);
@Outfiles   = ($outfilef, $outfileb);
IOcheck(\@Infiles, \@Outfiles);
Log("mai.pl", @args);

##### Running ROI #####
Message "$ROI_MAI/roi_mai  $roimai > $roiout";
`$ROI_MAI/roi_mai  $roimai > $roiout`;

Status "roi_mai";

$prf             = Use_rsc "$outfilef read PRF";

$OutStr = `cat $roiout`;
if( $OutStr =~ /Doppler coefficients referenced to output range bin[^\n]*\n[^\n]* (\S+)[^\n]*\n[^\n]* (\S+)[^\n]*\n[^\n]* (\S+)[^\n]*\n[^\n]* (\S+)/){
  $dop_rng0 = $1 / $prf;
  $dop_rng1 = $2 / $prf;
  $dop_rng2 = $3 / $prf;
  $dop_rng3 = $4 / $prf;
  Use_rsc "$outfilef write DOPPLER_RANGE0 $dop_rng0";
  Use_rsc "$outfilef write DOPPLER_RANGE1 $dop_rng1";
  Use_rsc "$outfilef write DOPPLER_RANGE2 $dop_rng2";
  Use_rsc "$outfilef write DOPPLER_RANGE3 $dop_rng3";
}else{
  warn "Could not read updated doppler coefficients from $roiout";
} 

Message "$INT_SCR/length.pl $outfilef";
Status "length.pl";

exit 0;

=pod

=head1 USAGE

B<mai.pl> I<date, master roi input file, roi_mai output file, forward slc name, aft slc name> 
  
=head1 FUNCTION

runs roi_mai

=head1 HISTORY

Perl  Script : Noa BD Bechor, 01/02/2008, modified from roi.pl
Modification: Noa BD Bechor, 25/Sep/2010

=head1 LAST UPDATE

Noa BD Bechor 2010/09/25

=cut

