
      program translate

      implicit none
      integer max_nnn,max_nl,cmax_nnn
      parameter (max_nnn=11000, max_nl=5000, cmax_nnn = max_nnn*2)
      REAL*8       PI,PI2
      integer nnn,nl,ideskew,isave1,isave2,nextend,iradelta
      integer ipatch,npatches,line,lineend,loopend
      real*4 wavl,b(cmax_nnn)
      real*4 vel1, prf1, veleff1
      real*4 vel2, prf2, veleff2
      real*8 dot
      real*8 f_f1,f_f2,f_b1,f_b2
      real*8 r01, fd_f,fd_ff,fd_fff, fd_ffff, ht1, r001
      real*8 r02, fd_b,fd_bb,fd_bbb, fd_bbbb, ht2, r002
      real*8 r1,r2,sin_diff,fs,delr
      real*8 fd_f1,fd_ff1,fd_fff1,fd_ffff1
      real*8 fd_f2,fd_ff2,fd_fff2,fd_ffff2
      real*8 fd_b1,fd_bb1,fd_bbb1,fd_bbbb1
      real*8 fd_b2,fd_bb2,fd_bbb2,fd_bbbb2
      real*8 re1, th1, thaz_f1, thaz_b1, sinsqref_f1, sinsqref_b1, acc1
      real*8 re2, th2, thaz_f2, thaz_b2, sinsqref_f2, sinsqref_b2, acc2
      real*8 r_platvel1(3), r_platacc1(3), r_lookvec1(3)
      real*8 r_vdotl1, r_adotl1,r_veln1
      real*8 r_platvel2(3), r_platacc2(3), r_lookvec2(3) 
      real*8 r_vdotl2, r_adotl2,r_veln2
      integer ia, j, k, l, i_lrl,nlooks, i
      integer n, nfc, nf0
      character*64 mai,maiout
      real*8 phase(max_nnn,max_nl),amp(max_nnn,max_nl)
      complex*8 box

       pi=4.d0*atan2(1.d0,1.d0)
       pi2=2.d0*pi
	

      read(*,'(a)')mai
      
      read(*,'(a)')maiout

      read(*,*)nnn                 	! azimuth patch size
      
      read(*,*)npatches			! number of patches
      
      read(*,*)nlooks			! number of looks in azimuth

      read(*,*)nl                 	! nlinesaz, # of range bins to process
      
      read(*,*)r001      		! r0 file 1 
      
      read(*,*)r002      		! r0 file 2 
      
      read(*,*)isave1      		! first range bin to process file 1
      
      read(*,*)isave2      		! first range bin to process file 2
      
      read(*,*)nextend      		! Chirp extension
      
      read(*,*)iradelta      		! Delta range pixels for second file 
      
      read(*,*)fs      		! Range sampling rate
      
      read(*,*)wavl      		! 
   
      read(*,*)vel1      		! Velocity file 1
      
      read(*,*)vel2      		! Velocity file 2
      
      read(*,*)fd_f,fd_ff,fd_fff,fd_ffff      		! Forward Doppler centroid
      
      read(*,*)fd_b,fd_bb,fd_bbb,fd_bbbb      		! Aft Doppler centroid
      
      read(*,*)prf1      		! PRF file 1
      
      read(*,*)prf2      		! PRF file 2
      
      read(*,*)ht1      		! Height file 1

      read(*,*)ht2      		! Height file 2

      read(*,*)re1      		! Earth Radius used for processing file 1

      read(*,*)re2      		! Earth Radius used for processing file 2
      
      read(*,*)r_platvel1(1),r_platvel1(2),r_platvel1(3)	! Velocity vector file 1
      
      read(*,*)r_platvel2(1),r_platvel2(2),r_platvel2(3)	! Velocity vector file 2

      read(*,*)r_platacc1(1),r_platacc1(2),r_platacc1(3)	! Acceleration vector file 2

      read(*,*)r_platacc2(1),r_platacc2(2),r_platacc2(3)	! Acceleration vector file 2

      read(*,*)i_lrl			! Left/right looking

	
	i = int(float(nnn)/float(nlooks))
	if (float(i).lt.float(nnn)/float(nlooks)) then
		nnn = i !+1
	else
		nnn = i
	endif	      

	print*, "Input file: ",mai
	print*, "Output file: ",maiout      
	print*, "Width: ",nl
	print*, nnn
	print*, "Number of Patches, Number of Looks, Patch Size: ",
     $		npatches, nlooks, nnn
      
      fd_f = fd_f * prf1
      fd_ff = fd_ff * prf1
      fd_fff = fd_fff * prf1
      fd_ffff = fd_ffff * prf1
      fd_b = fd_b * prf2
      fd_bb = fd_bb * prf2
      fd_bbb = fd_bbb * prf2
      fd_bbbb = fd_bbbb * prf2
      

      delr=299792456./fs/2.

c reference doppler coefficients to range
	
	fd_f1 = fd_f
	fd_ff1 = fd_ff
	fd_fff1 = fd_fff
	fd_ffff1 = fd_ffff
	fd_f2 = fd_f
	fd_ff2 = fd_ff
	fd_fff2 = fd_fff
	fd_ffff2 = fd_ffff
	
	fd_b1 = fd_b
	fd_bb1 = fd_bb
	fd_bbb1 = fd_bbb
	fd_bbbb1 = fd_bbbb
	fd_b2 = fd_b
	fd_bb2 = fd_bb
	fd_bbb2 = fd_bbb
	fd_bbbb2 = fd_bbbb

      call radopp(fd_f1,fd_ff1,fd_fff1,fd_ffff1,r001,delr)
      call radopp(fd_f2,fd_ff2,fd_fff2,fd_ffff2,r002,delr)
      call radopp(fd_b1,fd_bb1,fd_bbb1,fd_bbbb1,r001,delr)
      call radopp(fd_b2,fd_bb2,fd_bbb2,fd_bbbb2,r002,delr)


      r01 = r001 + (isave1-nextend-1) * delr
      r02 = r002 + (isave2-nextend-1+iradelta) * delr


c      call norm(r_platvel1,r_veln1)
c      call norm(r_platvel2,r_veln2)

      open(21,file=mai,access='direct',recl=nl*8)
      open(24,file=maiout,access='direct',recl=nl*8)

      
	do ipatch=1,npatches      
      		lineend = 0
		do line = 1+(ipatch-1)*nnn,ipatch*nnn
        		read(21,rec=line,err=99)(b(k),k=1,nl*2)
			lineend = line - (ipatch-1)*nnn
			do ia = 1,nl*2,2
				phase((ia+1)/2,lineend) = 
     $					atan2(b(ia+1),b(ia))
				amp((ia+1)/2,lineend) = 
     $					sqrt(b(ia)**2+b(ia+1)**2)
			end do			
		end do		
 99   		continue
 		print*, "Patch #, number of data lines: ",ipatch,lineend
 	     	do ia = 1 , nl
         		r1 = r01 + float(ia-1)*delr
	        	r2 = r02 + float(ia-1)*delr
        		f_f1 = fd_f1 + ( fd_ff1 + ( fd_fff1+fd_ffff1*r1 ) *r1 )*r1
         		f_f2 = fd_f2 + ( fd_ff2 + ( fd_fff2+fd_ffff2*r2 ) *r2 )*r2
         		f_b1 = fd_b1 + ( fd_bb1 + ( fd_bbb1+fd_bbbb1*r1 ) *r1 )*r1
         		f_b2 = fd_b2 + ( fd_bb2 + ( fd_bbb2+fd_bbbb2*r2 ) *r2 )*r2
         		th1=dacos(((ht1+re1)**2+r1*r1-re1**2)/(2.d0*r1*(re1+ht1)))
         		th2=dacos(((ht2+re2)**2+r2*r2-re2**2)/(2.d0*r2*(re2+ht2)))
         		if(i_lrl .eq. 0) then
            			sinsqref_f1 = f_f1 * wavl/(2.d0*vel1*sqrt(re1/(re1+ht1))*sin(th1))
            			sinsqref_f2 = f_f2 * wavl/(2.d0*vel2*sqrt(re2/(re2+ht2))*sin(th2))
            			sinsqref_b1 = f_b1 * wavl/(2.d0*vel1*sqrt(re1/(re1+ht1))*sin(th1))
            			sinsqref_b2 = f_b2 * wavl/(2.d0*vel2*sqrt(re2/(re2+ht2))*sin(th2))
	    			sin_diff = sinsqref_f1-sinsqref_b1
         		else
     
            thaz_f1 = asin(((wavl*f_f1/(2.d0*sin(th1)))+
     $	    	 (r_platvel1(3)/tan(th1)))/
     $           sqrt(r_platvel1(1)**2+r_platvel1(2)**2))-
     $		 i_lrl*atan(r_platvel1(2)/r_platvel1(1))
     
            thaz_f2 = asin(((wavl*f_f2/(2.d0*sin(th2)))+
     $	    	(r_platvel2(3)/tan(th2)))/
     $           sqrt(r_platvel2(1)**2+r_platvel2(2)**2))-
     $		 i_lrl*atan(r_platvel2(2)/r_platvel2(1))
     
            thaz_b1 = asin(((wavl*f_b1/(2.d0*sin(th1)))+
     $	     	(r_platvel1(3)/tan(th1)))/
     $           sqrt(r_platvel1(1)**2+r_platvel1(2)**2))-
     $		 i_lrl*atan(r_platvel1(2)/r_platvel1(1))
     
            thaz_b2 = asin(((wavl*f_b2/(2.d0*sin(th2)))+
     $	    	(r_platvel2(3)/tan(th2)))/
     $           sqrt(r_platvel2(1)**2+r_platvel2(2)**2))-
     $		 i_lrl*atan(r_platvel2(2)/r_platvel2(1))

	    sin_diff = sin(th1)*(sin(thaz_f1)-sin(thaz_b1))
			
         		end if
	 
		 	do line = 1,lineend
		 		phase(ia,line) = -phase(ia,line)*wavl/4.d0/pi/sin_diff
	 		end do
c			print*, wavl/4.d0/pi/sin_diff, th1*180.d0/pi, thaz_f1*180.d0/pi	 , thaz_b1*180.d0/pi
	 
		end do
       		do line = 1,lineend 
       			do ia=1,nl
				b(ia) = amp(ia,line)
				b(ia+nl) = phase(ia,line)
			end do		
        		write(24,rec=line+(ipatch-1)*nnn)(b(k),k=1,nl*2)
       		end do		
       
	end do
      
	close(21)
      	close(24)
      
      	end



      subroutine radopp(fd, fdd, fddd, fdddd, r, del)

      real*8 	fd, fdd, fddd, fdddd, r, del, temp1, temp2, temp3, temp4

      temp1 = fd
     .       - fdd   * (r/del)
     .       + fddd  * (r/del)**2
     .       - fdddd * (r/del)**3
      temp2 = fdd/del
     .       - 2.d0 * fddd  * (r/del)    /del
     .       + 3.d0 * fdddd * (r/del)**2 / del
      temp3 = fddd / del**2
     .       - 3.d0 * fdddd * (r/del) / del**2
      temp4 = fdddd / del**3

      fd    = temp1
      fdd   = temp2
      fddd  = temp3
      fdddd = temp4

      return
      end
